#include <windows.h>
#include <tlhelp32.h>
#include <string>
#include <vector>
#include "PEFile.h"


//=============================================================================

// tbNĒu֐̃vg^Cv錾
static int       WINAPI MyMessageBoxA(HWND, const char*, const char*, int);
static int       WINAPI MyMessageBoxW(HWND, const wchar_t*, const wchar_t*, int);
static HMODULE   WINAPI MyLoadLibraryA(const char*);
static HMODULE   WINAPI MyLoadLibraryW(const wchar_t*);
static HINSTANCE WINAPI MyLoadLibraryExA(const char*, HANDLE, DWORD);
static HINSTANCE WINAPI MyLoadLibraryExW(const wchar_t*, HANDLE, DWORD);
static FARPROC   WINAPI MyGetProcAddress(HMODULE, const char*);


//=============================================================================


//! DLL ŋLZNV
#pragma data_seg(".shared")
static HHOOK    s_hook_handle       = NULL;
static DWORD    s_caller_process_id = 0;
static DWORD    s_target_process_id = 0;
#pragma data_seg()
#pragma comment(linker, "/SECTION:.shared,rws")

//!  DLL ̃nhBDllMain() ŃZbgB
static HMODULE  s_my_dll_handle = NULL;

//! tbNC|[gV{̏
static struct {
  const char* dll_name;   // C|[gV{܂ DLL ̖O
  const char* func_name;  // C|[gV{̖OB
  void*       old_func_p; // C|[gV{̃|C^BDllMain() ŏB
  void*       new_func_p; // ũ|C^B
} s_hook_info[] = {
  { "kernel32.dll", "LoadLibraryA",   NULL, &MyLoadLibraryA },
  { "kernel32.dll", "LoadLibraryW",   NULL, &MyLoadLibraryW },
  { "kernel32.dll", "LoadLibraryExA", NULL, &MyLoadLibraryExA },
  { "kernel32.dll", "LoadLibraryExW", NULL, &MyLoadLibraryExW },
  { "kernel32.dll", "GetProcAddress", NULL, &MyGetProcAddress },
  { "user32.dll",   "MessageBoxA",    NULL, &MyMessageBoxA },
  { "user32.dll",   "MessageBoxW",    NULL, &MyMessageBoxW },
};


// z̗vf擾}N
#define numberof(X) ((sizeof(X)) / (sizeof((X)[0])))


//=============================================================================


//! fobOo
static void DebugOut(const wchar_t* i_format, ...)
{
  wchar_t message[1024] = { 0 };
  va_list val;

  va_start(val, i_format);
  wvsprintfW(message, i_format, val);
  va_end(val);

  OutputDebugStringW(message);
}


//=============================================================================


//! SetWindowsHookEx ɓntbNvV[WB
static LRESULT WINAPI GetMsgProc(int code, WPARAM wparam, LPARAM lparam)
{
  return CallNextHookEx(s_hook_handle, code, wparam, lparam);
}


//=============================================================================


//! tbNJnB
__declspec(dllexport) bool ImpHookStart(DWORD i_target_process_id)
{
  bool  retval = false;

  //  SetWindowsHookEx() Ă΂Ăꍇ͖B
  if( s_hook_handle == NULL )
  {
    s_hook_handle = SetWindowsHookEx(
                      WH_GETMESSAGE,
                      GetMsgProc,
                      s_my_dll_handle,
                      0 // target thread id
                    );
    
    s_caller_process_id = GetCurrentProcessId();
    s_target_process_id = i_target_process_id;
    retval = s_hook_handle != NULL;
  }
  
  return retval;
}


//=============================================================================


//! API tbNIB
__declspec(dllexport) bool ImpHookStop()
{
  bool  retval = false;
  
  if( s_hook_handle )
  {
    UnhookWindowsHookEx(s_hook_handle);
    s_hook_handle = NULL;
    retval = true;
  }
  
  return retval;
}


//=============================================================================


//! w肵W[̃C|[gV{̃tbN/AtbNsB
static bool HookImports(PEFile& io_pe_file, bool i_hook)
{
  for(size_t i = 0; i < numberof(s_hook_info); i++)
  {
    if( i_hook )
    {
      void** iat_entry_p = io_pe_file.HookImportSymbol(
                             s_hook_info[i].old_func_p,
                             s_hook_info[i].new_func_p
                           );
      if( iat_entry_p )
      {
        DebugOut(L"tbN܂B:%S@%S, %p\n",
                  s_hook_info[i].func_name, s_hook_info[i].dll_name, iat_entry_p
                );
      }
    }
    else
    {
      io_pe_file.HookImportSymbol(
        s_hook_info[i].new_func_p,
        s_hook_info[i].old_func_p
      );
    }
  }
  
  return true;
}


//=============================================================================


//! SẴW[̃C|[gV{̃tbN/AtbNsB
static bool HookImports(bool i_hook)
{
  bool          retval            = false;
  HANDLE        snapshot_handle   = INVALID_HANDLE_VALUE;
  MODULEENTRY32 module_entry      = { sizeof(MODULEENTRY32), 0 };
  
  do
  {
    // W[
    snapshot_handle = CreateToolhelp32Snapshot(
                        TH32CS_SNAPMODULE,
                        GetCurrentProcessId()
                      );
    for(BOOL is_next = Module32First(snapshot_handle, &module_entry);
        is_next;
        is_next = Module32Next(snapshot_handle, &module_entry))
    {
      //  DLL ł͂Ȃꍇ̂ IAT B
      if( module_entry.hModule != s_my_dll_handle )
      {
        HookImports(PEFile(module_entry.hModule), i_hook);
      }
    }
    
    retval = true;
  }
  while( 0 );
  
  if( snapshot_handle != INVALID_HANDLE_VALUE )
  {
    CloseHandle(snapshot_handle);
    snapshot_handle = INVALID_HANDLE_VALUE;
  }
  
  return retval;
}


//=============================================================================


//! DLL ̃Gg|CgBtbNsB
BOOL WINAPI DllMain(
  HINSTANCE   i_module_handle,
  DWORD       i_reason_for_call,
  void*
)
{
  switch( i_reason_for_call )
  {
  case DLL_PROCESS_ATTACH:
    s_my_dll_handle = reinterpret_cast<HMODULE>(i_module_handle);
    if( s_hook_handle
    &&  s_caller_process_id != GetCurrentProcessId()
    &&  (s_target_process_id == 0 || s_target_process_id == GetCurrentProcessId()) )
    {
      for(size_t i = 0; i < numberof(s_hook_info); i++)
      {
        s_hook_info[i].old_func_p = GetProcAddress(
                                      GetModuleHandleA(s_hook_info[i].dll_name),
                                      s_hook_info[i].func_name
                                    );
      }

      DebugOut(L"DLL_PROCESS_ATTACH ProcessId:%08X\n", GetCurrentProcessId());
      HookImports(true);
    }
    
    break;
  case DLL_PROCESS_DETACH:
    if( s_hook_handle
    &&  s_caller_process_id != GetCurrentProcessId()
    &&  (s_target_process_id == 0 || s_target_process_id == GetCurrentProcessId()) )
    {
      DebugOut(L"DLL_PROCESS_DETACH ProcessId:%08X\n", GetCurrentProcessId());
      HookImports(false);
    }
    break;
  }
  
  return TRUE;
}


//=============================================================================


//! MessageBoxA() ɑ֐B
static int WINAPI MyMessageBoxA(
  HWND          i_window_handle,
  const char*   i_message,
  const char*   i_title,
  int           i_type
)
{
  return MessageBoxA(
           i_window_handle,
           "All your base are belong to us.",
           i_title,
           i_type
         );
}


//=============================================================================


//! MessageBoxW() ɑ֐B
static int WINAPI MyMessageBoxW(
  HWND             i_window_handle,
  const wchar_t*   i_message,
  const wchar_t*   i_title,
  int              i_type
)
{
  return MessageBoxW(
           i_window_handle,
           L"All your base are belong to us.",
           i_title,
           i_type
         );
}


//=============================================================================


//! LoadLibraryA() ɑ֐B
static HMODULE WINAPI MyLoadLibraryA(const char* i_dll_name)
{
  HMODULE module_handle = LoadLibraryA(i_dll_name);

  if( module_handle )
    HookImports(PEFile(module_handle), true);
  
  return module_handle;
}


//=============================================================================


//! LoadLibraryW() ɑ֐B
static HMODULE WINAPI MyLoadLibraryW(const wchar_t* i_dll_name)
{
  HMODULE module_handle = LoadLibraryW(i_dll_name);

  if( module_handle )
    HookImports(PEFile(module_handle), true);
  
  return module_handle;
}


//=============================================================================


//! LoadLibraryExA() ɑ֐B
static HINSTANCE WINAPI MyLoadLibraryExA(
  const char* i_dll_name,
  HANDLE      i_reserved,
  DWORD       i_flags
)
{
  HMODULE module_handle = LoadLibraryExA(i_dll_name, i_reserved, i_flags);

  // LOAD_LIBRARY_AS_DATAFILE tOw肳ĂȂꍇtbNs
  if( module_handle && (i_flags & LOAD_LIBRARY_AS_DATAFILE) == 0 )
    HookImports(PEFile(module_handle), true);

  return module_handle;
}


//=============================================================================


//! LoadLibraryExW() ɑ֐B
static HINSTANCE WINAPI MyLoadLibraryExW(
  const wchar_t* i_dll_name,
  HANDLE         i_reserved,
  DWORD          i_flags
)
{
  HMODULE module_handle = LoadLibraryExW(i_dll_name, i_reserved, i_flags);

  // LOAD_LIBRARY_AS_DATAFILE tOw肳ĂȂꍇtbNs
  if( module_handle && (i_flags & LOAD_LIBRARY_AS_DATAFILE) == 0 )
    HookImports(PEFile(module_handle), true);

  return module_handle;
}


//=============================================================================


//! GetProcAddress() ɑ֐B
static FARPROC WINAPI MyGetProcAddress(
  HMODULE       i_module_handle,
  const char*   i_func_name
)
{
  FARPROC retval = GetProcAddress(i_module_handle, i_func_name);

  for(size_t i = 0; i < numberof(s_hook_info); i++)
  {
    if( s_hook_info[i].old_func_p == retval )
    {
      retval = reinterpret_cast<FARPROC>(s_hook_info[i].new_func_p);
      break;
    }
  }

  return retval;
}


//=============================================================================


